/**
 * find-package
 * Find lerna package by path or name
 */
import * as TE from 'fp-ts/TaskEither';
import { PackageDiscoveryError } from '@typescript-tools/lerna-packages';
import { LernaPackage } from '@typescript-tools/io-ts/dist/lib/LernaPackage';
export declare type FindPackageError = PackageDiscoveryError | {
    type: 'unable to find package in monorepo';
    package: string;
};
export declare const findPackageIn: (packages: LernaPackage[]) => (packagePathOrName: string) => TE.TaskEither<FindPackageError, LernaPackage>;
/**
 * Returns absolute path to the specified package.
 */
export declare const findPackage: (pathInsideMonorepo: string, packagePathOrName: string) => TE.TaskEither<FindPackageError, LernaPackage>;
//# sourceMappingURL=index.d.ts.map