"use strict";
/**
 * find-package
 * Find lerna package by path or name
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findPackage = exports.findPackageIn = void 0;
const path = __importStar(require("path"));
const A = __importStar(require("fp-ts/ReadonlyArray"));
const O = __importStar(require("fp-ts/Option"));
const TE = __importStar(require("fp-ts/TaskEither"));
const function_1 = require("fp-ts/function");
const lerna_packages_1 = require("@typescript-tools/lerna-packages");
const err = function_1.identity;
const findPackageByPath = (packages) => (packagePath) => function_1.pipe(packages, 
// FIXME: only works with relative paths
A.filter(({ location }) => location === path.resolve(process.cwd(), packagePath)), A.head);
const findPackageByName = (packages) => (packageName) => function_1.pipe(packages, A.filter(({ name }) => name === packageName), A.head);
const findPackageIn = (packages) => (packagePathOrName) => function_1.pipe(findPackageByPath(packages)(packagePathOrName), O.alt(() => findPackageByName(packages)(packagePathOrName)), O.fold(() => TE.left(err({ type: 'unable to find package in monorepo', package: packagePathOrName })), TE.right));
exports.findPackageIn = findPackageIn;
/**
 * Returns absolute path to the specified package.
 */
const findPackage = (pathInsideMonorepo, packagePathOrName) => function_1.pipe(lerna_packages_1.lernaPackages(pathInsideMonorepo), TE.chain(packages => exports.findPackageIn(packages)(packagePathOrName)));
exports.findPackage = findPackage;
//# sourceMappingURL=index.js.map